<?php

class widgetContentRandomitem extends cmsWidget {

    public function run(){

        $this->setWrapper('wrapper_plain');

        $id           = $this->getOption('id');

        $cat_id           = $this->getOption('category_id');
        $ctype_id         = $this->getOption('ctype_id');
        $dataset_id       = $this->getOption('dataset');
        $image_field      = $this->getOption('image_field');
        $image_preset     = $this->getOption('image_preset');
        $teaser_fields    = $this->getOption('teaser_field');
        $limit            = $this->getOption('limit', 10);
        $delay_random     = $this->getOption('delay_random');
        $period_random    = $this->getOption('period_random');

        // Внешний вид

        $x_pos            = $this->getOption('x_pos');
        $y_pos            = $this->getOption('y_pos');
        $random_width     = $this->getOption('random_width');
        $random_bg        = $this->getOption('random_bg');
        $random_radius    = $this->getOption('random_radius');
        $t_color          = $this->getOption('t_color');
        $teaser_color     = $this->getOption('teaser_color');
        $show_title       = $this->getOption('show_title');
        $title_t          = $this->getOption('title_t');
	
        $model = cmsCore::getModel('content');

        $ctype = $model->getContentType($ctype_id);
        if (!$ctype) { return false; }

		if ($cat_id){
			$category = $model->getCategory($ctype['name'], $cat_id);
		} else {
			$category = false;
		}

        if ($dataset_id){

            $dataset = $model->getContentDataset($dataset_id);

            if ($dataset){
                $model->applyDatasetFilters($dataset);
            } else {
                $dataset_id = false;
            }

        }

		if ($category){
			$model->filterCategory($ctype['name'], $category, true);
		}

        // применяем приватность
        // флаг показа только названий
        $hide_except_title = $model->applyPrivacyFilter($ctype, cmsUser::isAllowed($ctype['name'], 'view_all'));

        // Скрываем записи из скрытых родителей (приватных групп и т.п.)
        $model->enableHiddenParentsFilter();

        // выключаем формирование рейтинга в хуках
        $ctype['is_rating'] = 0;

		list($ctype, $model) = cmsEventsManager::hook('content_list_filter', array($ctype, $model));
		list($ctype, $model) = cmsEventsManager::hook("content_{$ctype['name']}_list_filter", array($ctype, $model));

        $items = $model->limit($limit)->getContentItems($ctype['name']);
        if (!$items) { return false; }

        list($ctype, $items) = cmsEventsManager::hook("content_before_list", array($ctype, $items));
        list($ctype, $items) = cmsEventsManager::hook("content_{$ctype['name']}_before_list", array($ctype, $items));

        return array(

            'id'                => $this->id,
		
            'widget_id'         => $this->bind_id,
            'op'                => $this->options,
            'ctype'             => $ctype,
            'image_field'       => $image_field,
            'image_preset'      => $image_preset,
            'teaser_field'      => $teaser_fields,
            'items'             => $items,
            'delay_random'      => $delay_random,
            'period_random'     => $period_random,

            // Внешний вид

            'x_pos'             => $x_pos,
            'y_pos'             => $y_pos,
            'random_width'      => $random_width,
            'random_bg'         => $random_bg,
            'random_radius'     => $random_radius,
            't_color'           => $t_color,
            'teaser_color'      => $teaser_color,
            'show_title'        => $show_title,
            'title_t'           => $title_t
			
        );

    }

}
